/*
 * Copyright (c) 1997.  Sun Microsystems.  All rights reserved.
 * 
 * Modify an entry:
 *  - replace any existing values in the "mail" attribute with "babs@ace.com"
 *  - add a new value to the "description" attribute
 *
 * [equivalent to modattrs.c in Netscape SDK]
 */

import java.util.Hashtable;
import java.util.Date;
 
import javax.naming.*;
import javax.naming.directory.*;

class Modattrs {

public static void main(String[] args) {

    Hashtable env = new Hashtable();
    /*
     * Specify the initial context implementation to use.
     * This could also be set by using the -D option to the java program.
     * For example,
     * This could also be set by using the -D option to the java program.
     *   java -Djava.naming.factory.initial=com.sun.jndi.ldap.LdapCtxFactory Compare
     */
    env.put("java.naming.factory.initial", Env.INITCTX);

    /* Specify host and port to use for directory service */
    env.put("java.naming.provider.url", Env.MY_SERVICE);

    /* specify authentication information */
    env.put("java.naming.security.principal", Env.MGR_DN);
    env.put("java.naming.security.credentials", Env.MGR_PW);

    try {
        /* get a handle to an Initial DSContext */
        DirContext ctx = new InitialDirContext(env);

        /* construct the list of modifications to make */
        ModificationItem[] mods = new ModificationItem[3];

        Attribute mod0 = new Attribute("mail", "babs@eng");
	// Update mail attribute
        mods[0] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE, mod0);

	// Add another value to description attribute
        Attribute mod1 = 
            new Attribute("description", 
                          "This entry was modified with the Modattrs program on " +
                          (new Date()).toString());
        mods[1] = new ModificationItem(DirContext.ADD_ATTRIBUTE, mod1);

	 /* Delete the description attribute altogether */
	/*
        Attribute mod1 =  new Attribute("description");
        mods[2] = new ModificationItem(DSContext.DELETE_ATTRIBUTE, mod1);
	*/

        /* make the change */
        ctx.modifyAttributes(Env.ENTRYDN, mods);
        System.out.println( "modification was successful" );

    } catch (NamingException e) {
        System.err.println("modification failed" + e);
    }
}
}

